<?php /*** Shampoo 0.7, (c) 2008-2011 R Holt ( http://ratherodd.com )               ****
      **** Don't edit this file unless you know what you're doing.                  ****
      **** Please read readme.txt. This script requires PHP 5 or above.             ****/

error_reporting(E_ALL ^ E_NOTICE);

ini_set("session.bug_compat_42", 0);
session_name('fish');
$sok = @session_start();
if(!$sok){
  session_regenerate_id(true);
  session_start();
}
if ($_GET['admin'] && $_GET['admin'] === 'end') {
  unset($_SESSION['admin']);
  header('Location: ' . strtok($_SERVER['REQUEST_URI'], '?')); // remove query string
  exit;
}

//handle image requests for passworded albums
if ($_GET['imgreq'] && $_GET['imgext']) {
  if ($_SESSION['access'][$_GET['album']] || $_SESSION['admin']) {
    $imgstr = utf8_decode(urldecode($_GET['th'] . $_GET['album'] . '/' . $_GET['imgreq'] . '.' . $_GET['imgext']));
    $fs = stat($imgstr);
    $mimeext = $_GET['imgext'] === 'jpg' ? 'jpeg' : $_GET['imgext'];
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s', $fs['mtime']) . ' GMT');
    header('Content-Type: image/' . strtolower($mimeext));
    header('Content-Length: ' . $fs['size']);
    header('Pragma: public');
    header("Cache-Control: maxage=1200000");
    header("Etag: ".sprintf('"%x-%x-%s"', $fs['ino'], $fs['size'],base_convert(str_pad($fs['mtime'],16,"0"),10,16)));
    header('Expires: ' . gmdate('D, d M Y H:i:s', time()+1200000) . ' GMT');
    readfile($imgstr);
    exit();
  }
  else $fish = array($_GET['album'], $_GET['imgreq'] . '_' . $_GET['imgext']);
}

require_once 'functions.php';
require_once 'settings.php';

if (!$fish) $fish = explode('/', ltrim(substr(utf8_decode(urldecode($_SERVER['REQUEST_URI'])), strlen(dirname($_SERVER['SCRIPT_NAME']))), '/'));

header('Content-Type: text/html; charset=utf-8');
$shampoo = new Shampoo($fish[0]);
$shampoo->register_var('base', BASE);
$shampoo->register_var('version', VERSION);
$shampoo->addBodyClass($_SESSION['fixed']);
$shampoo->admin_password = $shampoo->get_password(false);

if (!$shampoo->admin_password || isset($_POST['newpassword1'])) {
  require_once('admin.php');
  change_admin_password();
}
else {
  if (isset($_POST['admin_password'])) {
    if (utf8_encode(hash('tiger192,4', trim($_POST['admin_password']))) === $shampoo->admin_password) $_SESSION['admin'] = true;
    else {
      $shampoo->register_var('content', '<p id="change_password_box">Wrong password.</p>');
      $shampoo->addHeadCSS('#change_password_box {font:1em "Lucida Grande",Verdana,sans-serif;color:#3A4C09;border:2px solid #BA2804;background:#F6FCE5;padding:0.6em 1em;}');
    }
  }
  if ($_SESSION['admin'] === true) start_admin_session();
}

function start_admin_session() {
  global $shampoo;
  $_SESSION['admin'] = true;
  $shampoo->register_var('js', '<script type="text/javascript" src="js/admin.js"></script>');
  $shampoo->register_var('links', '  <link rel="stylesheet" href="js/admin.css" type="text/css" media="screen">');
}

if ($shampoo->album && $shampoo->admin_password) {
  $shampoo->register_var('title', $shampoo->{$shampoo->album}->title);
  $shampoo->albumate($fish);
}
else {
  $shampoo->register_var('header', $shampoo->title);
  $shampoo->register_var('title', $shampoo->title);
  $shampoo->showList();
}
$shampoo->makeMenu();
$shampoo->output('shampoo.inc');
?>