var admin = {
  toolbar: $c('span', {className: 'toolbar'}),
  init: function() {
    footlink.firstChild.nodeValue = 'End admin session';
    footlink.href += '=end';
    credit.appendChild($c('a', {href:'#change_password', onclick:change_admin_password}, 'Change password'));
    var editables_selectors = {
      maintitle: 'h1:not(:contains(\u00BB)), h1 > a:first-child', //\u00BB = &raquo;
      albumtitle: 'h1 > a:last-child, h1 > span:last-child, #albumarray h3 > a:first-child',
      maindesc: 'h1 + div',
      albumdesc: '#albumarray > li > p.description, h1 ~ p.description',
      caption: '#thumbarray .caption, #view .caption',
      images: '#albumarray > li > div > a, #thumbarray > li > a, #view > div > img'
    },
      actions = ['edit', 'cancel', 'save'],
      field, editables, save, cancel, icon, action, tools, x = i = 0;
    admin.albumlist = $('#albums');
    if (admin.bar = $('#bar', wrapper)) {
      if (thumbarray) {
        var lis = $('li', thumbarray, true), lilen = lis.length, z = 0;
        for (; z < lilen; z++) {
          lis[z].appendChild($('span.caption', lis[z]));
        }
      }
      else thumbarray = wrapper.insertBefore($c('ul', {id:'thumbarray'}), admin.bar.nextSibling);
      if ('draggable' in admin.bar) set_dragdrop();
      set_upload_button();
      set_password_changer();
    }
    if (!albumarray) admin.album = basename($('a.current', admin.albumlist).href);
    if (albumarray || !view) {
      var albums = albumarray ? $('li', albumarray, true) : [wrapper],
          alength = albums.length, newdesc, htype = albumarray ? '3' : '1';
      for (i = 0; i < alength; i++) {
        if (!$('h'+htype+' ~ p.description', albums[i])) {
          newdesc = albumarray ? albums[i].appendChild($c('p')) : wrapper.insertBefore($c('p'), $('h1 + p + *', wrapper));
          newdesc.appendChild($t('Add a description'));
          newdesc.className = 'description emptydesc';
        }
      }
    }
    for (; x < 3; x++) {
      action = actions[x];
      icon = this.toolbar.appendChild($c('a', {
        href: '#' + action,
        title: action.charAt(0).toUpperCase() + action.substr(1),
        className: action + ' hide'
      }, action));
    }
    for (field in editables_selectors) {
      editables = $(editables_selectors[field], wrapper, true);
      for (i = 0; i < editables.length; i++) {
        make_editable(editables[i], field);
      }
    }
    admin.albumlist.insertBefore($c('a', {href: '#new_album', className: 'standout', onclick: new_album}, 'Create new album'), $('ul', admin.albumlist));
    return false;
  }
};
admin.init();

function make_editable(editable, field) {
  if (field === 'images') {
    image_deletion(editable);
    return;
  }
  if (albumarray && field === 'albumtitle') {
    album_deletion(editable);
  }
  editable.ident = field;
  editable.contentEditable = false;
  var tools = editable.parentNode.insertBefore(admin.toolbar.cloneNode(true), editable);
  tools.firstChild.onfocus = function() {
    addClass(this.parentNode.nextSibling, 'focus');
  }
  tools.firstChild.onblur = function() {
    removeClass(this.parentNode.nextSibling, 'focus');
  }
  tools.style.top = editable.offsetTop + 'px';
  tools.style.left = (editable.offsetLeft - 40) + 'px';
  var editicon = tools.firstChild;
  removeClass(editicon, 'hide');
  editicon.onclick = edit;
  editicon.nextSibling.onclick = cancel_changes;
  tools.lastChild.onclick = save_changes;
}

function new_album() {
  if (this.active) return box_highlight(this.box);
  var newalbumlink = this,
      box = this.box = this.box || $c('div', {className:'admin_action invisible'});
  this.active = true;
  box.innerHTML = '<form action="admin.php?action=new_album" method="post"><h2>Create a new album</h2><fieldset id="newalbum"><legend>Create a new album</legend><label for="new_album_name">Name</label><input id="new_album_name" type="text" name="name"><p>This will be used as the directory name and is what users will see in the address bar.</p><label for="new_album_title">Title</label><input id="new_album_title" type="text" name="title"><p>The title of your album.</p><label for="new_album_description">Description</label><textarea rows="4" id="new_album_description" name="description"></textarea><p>This will appear at the top of the album and on the front page where all the albums are listed. HTML is allowed.</p><p class="hide error"> </p><input type="submit" value="Make it!"></fieldset></form>';
  wrapper.appendChild(box);
  box.oncurtainclick = function() {
    curtain(box);
    return newalbumlink.active = false;
  }
  var newalbumname = $('#new_album_name');
  newalbumname.onkeyup = newalbum_checkinput;
  newalbumname.onpaste = function() {
    window.setTimeout(function() {
      newalbum_checkinput.call(newalbumname);
    }, 5);
  }
  curtain(box);
  $('textarea', box).onkeyup = autogrow;
  $('#new_album_name', box).focus();
  return false;
}

function newalbum_checkinput() {
  var err = '';
  this.errors = ['<span>The album name can\'t start with a dot.</span>', '<span>The following characters cannot be used: </span><span>" 	* 	/ 	: 	< 	> 	? 	\ 	|</span>'];
  if (!this.errornode) {
    this.errornode = $('.error', this.parentNode);
    this.errornode.style.left = this.nextSibling.offsetLeft + 'px';
    this.errornode.style.top = this.nextSibling.offsetTop + 'px';
  }
  if (this.value.charAt(0) === '.') err += this.errors[0];
  if (/["*/:<>?\|]/.test(this.value)) err += this.errors[1];
  if (err.length > 0) {
    this.nextSibling.style.visibility = 'hidden';
    this.errornode.innerHTML = err;
    removeClass(this.errornode, 'hide');
  }
  else {
    addClass(this.errornode, 'hide');
    this.nextSibling.style.visibility = '';
  }
}

function box_highlight(box) {
  box.style.borderColor = '#CE2D04';
  var h2 = $('h2', box);
  h2.style.backgroundColor = '#CE2D04';
  window.setTimeout(function() {
    box.style.borderColor = '';
    h2.style.backgroundColor = '';
  }, 600);
  return false;
}

function change_admin_password() {
  var changer = this, box = this.box = this.box || $c('div', {className:'admin_action invisible'}), error, frm;
  box.style.width = box.style.minWidth = '36em';
  if (this.active) return curtain(box);
  this.active = true;
  box.innerHTML = '<h2>Change admin password</h2><form><label for="oldadminpassword" class="wide">Old password:</label><input id="oldadminpassword" type="password" name="oldadminpassword"><label for="newadminpassword1" class="wide">New password:</label><input id="newadminpassword1" type="password" name="newadminpassword1"><label for="newadminpassword2" class="wide">And again:</label><input id="newadminpassword2" type="password" name="newadminpassword2"><p class="hide error" style="position:static;width:auto"> </p><input type="submit" value="Change password"></form>';
  frm = $('form', box);
  wrapper.appendChild(box);
  error = $('p.error', box);
  frm.onsubmit = function() {
    var blank = [], valid = [], inputs = $('input[type=password]', box);
    each(inputs, function(i) {
      if (trim(i.value) === '') blank.push(i);
      else valid.push(i.name+'='+i.value);
    });
    if (blank.length > 0) return false;
    if (inputs[1].value !== inputs[2].value) {
      error.innerHTML = 'Error: New passwords don\'t match.';
      removeClass(error, 'hide');
      return false;
    }
    ajax(
      valid.join('&'),
      function(r) {
        if (r === '1') {
          box.removeChild(frm);
          box.innerHTML += '<p>Your password was changed.</p><p style="clear:left;margin:0 2em 0;width:auto;float:right"><button onclick="this.parentNode.parentNode.oncurtainclick()">Close</button></p>';
          $('button', box).focus();
        }
        else {
          error.innerHTML = r;
          removeClass(error, 'hide');
          frm.lastChild.value = 'Change password';
        }
      },
      '/admin.php?action=change_admin_password'
    );
    frm.lastChild.value = 'Submitting...';
    return false;
  }
  box.oncurtainclick = function() {
    curtain(box);
    return changer.active = false;
  }
  curtain(box);
  $('input:first', box).focus();
  return false;
}

function set_password_changer() {  
  var current = $('a.current', admin.albumlist), pw = hasClass(current, 'private'), imc = $('h1 + p.imagecount') || wrapper.insertBefore($c('p', {className:'imagecount'}), $('h1', wrapper).nextSibling), lab;
  imc.innerHTML += '<label for="new_password"><a href="#password_change">' + (pw ? 'Delete' : 'Add a') + ' password</a></label>';
  imc.innerHTML += pw ? ' <img src="img/lock.gif" width="8" height="10" title="Private album - visitors will be asked for a password" alt="(Private)">' : '<input type="text" id="new_password"><input type="button" value="OK">';
  $('label > a', imc).onclick = function() {
    lab = this.parentNode;
    if (!pw) {
      if (lab.className) {
        lab.className = null;
        this.firstChild.nodeValue = trim(this.firstChild.nodeValue, ':');
      }
      else {
        this.firstChild.nodeValue += ':';
        lab.className = 'active';
      }
      this.blur();
      lab.nextSibling.focus();
    }
    else change_password.call(this);
    return false;
  }
  imc.lastChild.onclick = change_password;
  imc.lastChild.previousSibling.onkeypress = function(e) {
    if ((window.event ? window.event.keyCode : e.which) === 13) change_password.call(this);
  }
  function change_password() {
    var trigger = this, val = '', oldchild, p;
    if (this.nodeName.toLowerCase() === 'input') {
      val = trim((this.type === 'button' ? this.previousSibling : this).value);
      if (val.length < 1) return false;
    }
    else trigger = this.parentNode;
    p = trigger.parentNode;
    ajax(
      'pw=' + val,
      function(r) {
        if (r === '1') {
          if (val) addClass(current, 'private');
          else removeClass(current, 'private');
          alert('Password ' + (val ? 'set' : 'deleted'));
          while (lab.nextSibling) {
            p.removeChild(lab.nextSibling);
          }
          p.removeChild(lab);
          set_password_changer();
        }
        else alert(r);
      },
      '/admin.php?action=' + (val ? 'set' : 'delete') + '_password&album=' + admin.album
    );
    return false;
  }
}

function set_upload_button() {
  var form = admin.bar.appendChild($c('form', {action:'admin.php?action=upload', method:'post', enctype:'multipart/form-data', encoding:'multipart/form-data'})),
    label = form.appendChild($c('label', {className:'uploader'}, 'Add images')),
    fileinput = label.appendChild($c('input', {type:'file', multiple:'multiple', name:'uploaded_images[]', onchange:handle_files}));
  if (fileinput.files) fileinput.title = 'You can add multiple files at once by holding CTRL while selecting them';
  else fileinput.removeAttribute('multiple');
  return false;
}

function set_dragdrop() {
  admin.bar.appendChild($c('span', {id:'dragdrop_infotext'}, 'or just drag and drop them onto the page'));
  var dragcurtain = wrapper.insertBefore($c('div', {id:'dragcurtain'}), thumbarray.nextSibling),
      dctext = dragcurtain.appendChild($c('span', null, 'Drop files here')),
      nothingp = $('#dragcurtain + p', wrapper);
  dragcurtain.style.top = thumbarray.offsetTop + 'px';
  if (!thumbarray.firstChild && nothingp) nothingp.style.lineHeight = '220px';
  document.ondragover = function(e) {
    e.preventDefault();
    window.clearTimeout(admin.dragleave_timer);
    var d = e.dataTransfer;
    if (d && (d.files || (d.types.contains && d.types.contains('Files')))) {
      dragcurtain.style.height = Math.max(thumbarray.offsetHeight, 220) + 'px';
      dctext.style.top = Math.max((thumbarray.offsetHeight / 2 - 40), 70) + 'px';
      dragcurtain.style.display = 'block';
      if (e.target === dragcurtain || contains(dragcurtain, e.target)) addClass(dragcurtain, 'dragover');
      else removeClass(dragcurtain, 'dragover');
    }
  }
  document.ondragenter = function(e) {
    e.preventDefault();
    e.stopPropagation();
  }
  document.ondragleave = function(e) {
    e.preventDefault();
    admin.dragleave_timer = window.setTimeout(function() {
      removeClass(dragcurtain, 'dragover');
      dragcurtain.style.display = '';
    }, 200);
    return false;
  }
  dragcurtain.ondrop = function(e) {
    e.stopPropagation();
    e.preventDefault();
    removeClass(dragcurtain, 'dragover');
    dragcurtain.style.display = '';
    handle_files.call(e.dataTransfer);
  }
}

function handle_files() {
  var files = this.files;
  if (!admin.filelist) admin.filelist = {};
  if (!files) return iframe_upload(this);
  var file, i = 0, j = files.length, p = $('#bar ~ p:not(#credit)'), li, img, added = [];
  while (p && p[i]) p[i++].style.display = 'none';
  for (i = 0; i < j; i++) {
    file = files[i];
    if (!file.name && file.fileName) file.name = file.fileName; // FF3.5 (only) uses fileName
    if (admin.filelist[file.name]) {
      added.push(file.name);
      continue;
    }
    li = (admin.filelist[file.name] = {li:thumbarray.appendChild($c('li')), size:file.size}).li;
    li.innerHTML = '<a href="' + admin.album + '/' + file.name + '" title="' + file.name + '"><span>Hang on...<img></span></a><span class="caption" contenteditable="false">' + file.name + '</span>';
    img = $('img', li);
    img.style.display = 'none';
    if (!readImage(file, img, li)) {
      upload(file, img, li, upload_result);
    }
  }
  if (this.parentNode) {
    this.parentNode.parentNode.parentNode.removeChild(this.parentNode.parentNode);
    set_upload_button();
  }
}

function readImage(file, img, li) {
  if (file.size < 204800 && window.FileReader) { // if files are too big, browser freezes
    var reader = new FileReader();
    reader.onloadend = (function(file, img, li) {
      return function() {
        img.onload = function(e) {
          if (Math.max(this.width, this.height) > 140) {
            if (this.width >= this.height) {
              this.height = 140 * this.height / this.width;
              this.width = 140;
            }
            else if (this.height >= this.width) {
              this.width = 140 * this.width / this.height;
              this.height = 140;
            }
          }
          if (img.previousSibling && img.previousSibling.nodeValue === 'Hang on...') img.parentNode.removeChild(img.previousSibling);
          img.style.visibility = '';
          if (li) upload(file, img, li, upload_result);
          this.onload = null; // change to server-generated thumb src would fire event again
        }
        img.src = this.result;
      }
    })(file, img, li);
    reader.readAsDataURL(file);
    return true;
  }
  return false;
}

function upload(file, img, li, callback) {
  var prog = li.insertBefore($c('span', {className:'upload_progress inprogress'}, 'waiting...'), $('span.caption', li)),
      cancel = prog.appendChild($c('a', {href:'#cancel'}, 'cancel'));
  var req = ajax(
    file,
    function(r) {
      prog.firstChild.nodeValue = '\u2714 ' + format_size(file.size);
      removeClass(prog, 'inprogress');
      prog.removeChild(cancel);
      if (callback) callback(r, img, li, file.name);
    },
    '/admin.php?action=upload&album=' + admin.album + '&name=' + file.name,
    'upload',
    function(loaded, total) {
      if (!prog.total) prog.total = total;
      prog.firstChild.nodeValue = Math.round(loaded / total * 100) + '% of ' + format_size(total);
    }
  );
  cancel.onclick = function() {
    req.abort();
    li.parentNode.removeChild(li);
    return false;
  }
}

function upload_result(response, img, li, filename) {
  if (response.charAt(0) === '{') {
    var data = jsonParse(response), datum;
    if (data.src) {
      var dummy = $c('img', {src:data.src});
      dummy.onload = function() {
        if (img.previousSibling && img.previousSibling.nodeValue === 'Hang on...') img.parentNode.removeChild(img.previousSibling);
        img.style.display = '';
        for (datum in data) img[datum] = data[datum];
        img.parentNode.parentNode.href = admin.album + '/' + data.alt.replace(/\.(?!.*\..*)/,'_');
        $('span.caption', li).firstChild.nodeValue = data.alt;
        make_editable($('a:first-child', li, true)[0], 'images');
        make_editable($('span.caption', li), 'caption');
      }
    }
    else if (data.newfile) { // handling duplicates
      admin.already_added = admin.already_added || wrapper.appendChild($c('div', {className:'invisible duplicate_handler', innerHTML:'<p>Some of the images chosen for upload have the same name as existing images in the album. If you close this box without taking action, the new images will be discarded.</p><ul></ul>'}));
      var ul = $('ul', admin.already_added),
          newfile = data.newfile,
          oldfile = data.oldfile,
          dupes = ul.appendChild($c('li')),
          decisions = ['Keep it', 'Discard it'],
          div, decision, i = 0;
      dupes.li = li;
      admin.already_added.oncurtainclick = function() {
        var lis = $('li', ul, true);
        for (var i = 0, j = lis.length; i < j; i++) {
          lis[i].li.parentNode.removeChild(lis[i].li);
          lis[i].parentNode.removeChild(lis[i]);
        }
        curtain(admin.already_added);
        ajax(null, null, '/admin.php?action=handle_duplicate&decision=emptytemp');
        return false;
      }
      ul.style.height = ((self.innerHeight || document.documentElement.clientHeight) * 0.68 - ul.offsetTop) + 'px';
      dupes.innerHTML = '<h5>' + filename + '</h5><div><img src="' + newfile.thumbpath + '" ' + newfile.thumbatt + '><strong>New image</strong><span>' + format_size(newfile.filesize) + '</span><span>' + newfile.width + ' x ' + newfile.height + '</span></div><div><img src="' + oldfile.thumbpath + '" ' + oldfile.thumbatt + '><strong>Existing image</strong><span>' + format_size(oldfile.filesize) + '</span><span>' + oldfile.width + ' x ' + oldfile.height + '</span></div><div></div>';
      dupes.data = data;
      div = $('h5 + div', dupes);
      for (; i < 2; i++) {
        div.appendChild($c('a', {
          href:'#',
          decision: decisions[i],
          onclick:function() {
            this.className = 'inprogress local_right';
            var decision = this.decision;
            ajax(
              'data=' + response,
              function(r) {
                if (decision === 'Keep it') {
                  var data = jsonParse(r);
                  li.innerHTML = '<a href="' + data.imagepath + ' " title="' + data.title + '"><span><img src="' + data.thumbpath + '" ' + data.thumbatt + ' alt="' + data.alt + '"></span></a><span class="caption" contenteditable="false">' + data.caption + '</span>';
                  img = $('img', li);
                  img.style.visibility = '';
                  make_editable($('a:first-child', li, true)[0], 'images');
                  make_editable($('span.caption', li), 'caption');
                }
                else li.parentNode.removeChild(li);
                ul.removeChild(dupes);
                if (!ul.firstChild) curtain(admin.already_added);
              },
              '/admin.php?action=handle_duplicate&decision=' + decision
            );
            return false;
          }
        }, decisions[i]));
      }
      if (!admin.curtain || !admin.curtain.visible) curtain(admin.already_added);
    }
  }
}

function iframe_upload(fileinput) {
  var iframe = admin.iframe = admin.iframe || wrapper.appendChild($c('iframe', {src:'javascript:;', id:'shampoo_upload_iframe', name:'shampoo_upload_iframe'})),
      imgname = basename(fileinput.value),
      li = thumbarray.appendChild($c('li', {innerHTML:'<a href="' + admin.album + '/' + imgname + '" title="' + imgname + '"><span>Hang on...<img></span></a><span class="caption" contenteditable="false">' + imgname + '</span>'})),
      img = $('img', li),
      upload_form = $('form:eq(1)', admin.bar);
  img.style.display = 'none';
  if (iframe.attachEvent) {
    iframe.attachEvent('onload', insert_thumb); // iframe.onload doesn't work in IE
  }
  else iframe.onload = insert_thumb;
  upload_form.action += '&src=iframe&album=' + admin.album + '&name=' + basename(imgname);
  upload_form.target = 'shampoo_upload_iframe';
  //alert(upload_form.tagName);
  upload_form.submit();
  function insert_thumb() {
    upload_result(trim(iframe.contentWindow.document.body.firstChild.nodeValue, '"'), img, li, imgname);
    make_editable($('a:first-child', li, true)[0], 'images');
    make_editable($('span.caption', li), 'caption');
    if (iframe.detachEvent) iframe.detachEvent('onload', insert_thumb); // must kill reference to this function
  }
  return false;
}

function curtain(el) {
  admin.curtain = admin.curtain || document.body.appendChild($c('div', {id: 'shampoo_curtain'}));
  el.closer = el.appendChild($c('a', {href:'#close', className:'deleter'}));
  el.closer.title = 'Close box';
  admin.curtain.visible = !admin.curtain.visible;
  toggleDisplay(admin.curtain, admin.curtain.visible);
  toggleVis(el);
  admin.curtain.onclick = el.closer.onclick = el.oncurtainclick || function() {
    curtain(el);
    return false;
  };
}

function format_size(bytes) {
  var i = -1;
  do {
    bytes = bytes / 1024;
    i++;
  } while (bytes > 999);
  return Math.max(bytes, 0.1).toPrecision(3) + ['kB', 'MB', 'GB'][i];
}

function image_deletion(img) {
  var imghref = basename(thumbarray || albumarray ? img.href.replace(/_(?!.*_.*)/,'.') : img.src), album = admin.album || basename($('h3 > a[contenteditable]', img.parentNode.parentNode).href),
      deleter = img.parentNode.insertBefore($c('a', {
        className: 'deleter',
        href: '#delete_' + imghref.split('/').pop(),
        title: 'Delete this image and its caption'
      }, 'Delete'), img);
  if (albumarray) {
    if (hasClass(img, 'thumbhide')) addClass(deleter, 'thumbhide');
    positionDeleter(deleter, img);
  }
  if (view) {
    var im = $('img', view)[0];
    addClass(deleter, 'withtext');
    deleter.style.right = Math.min(view.offsetWidth/2 - $('form + p', view).offsetWidth/2 - 40, Math.max(view.offsetWidth - im.offsetLeft - im.offsetWidth, $('fieldset', view).offsetWidth + deleter.offsetWidth + 20)) + 'px';
  }
  deleter.onclick = function() {
    addClass(this, 'inprogress');
    var imgs = img.parentNode.getElementsByTagName('img'); // live NodeList (hence not using $)
    ajax(null, function(r) {
      var imgpar = img.parentNode;
      if (albumarray) {
        deleter.parentNode.removeChild(deleter);
        imgpar.removeChild(img.nextSibling.nextSibling);
        imgpar.removeChild(img);
        for (var i = 0, j = imgs.length; i < j; i++) positionDeleter(imgs[i].parentNode.previousSibling, imgs[i].parentNode);
        if (!imgs.length) {
          imgpar.parentNode.insertBefore($c('p', null, 'This album is devoid of images!'), imgpar);
          var p = $('p.description', imgpar.parentNode);
          imgpar.parentNode.removeChild(imgpar);
          p.previousSibling.style.top = p.offsetTop + 'px';
        }
      }
      else if (view) window.location = ($('form + p > a:last-child', view) || $('a.current', admin.albumlist)).href;
      else {
        imgpar.parentNode.removeChild(imgpar);
        if (!$('li', thumbarray)) {
          var p = $('#bar ~ p:not(#credit)'), i = 0;
          while (p && p[i]) p[i++].style.display = '';
        }
      }
    }, '/admin.php?action=delete_image&image=' + imghref + '&album=' + album);
    return false;
  }
}

function album_deletion(albumtitle) {
  var title = albumtitle.firstChild.nodeValue, deleter = albumtitle.parentNode.appendChild($c('a', {className: 'albumdeleter', href: '#delete-album', title: 'Delete "' + title + '"'}, 'Delete album')),
      album = basename(albumtitle.href);
  deleter.onclick = function() {
    if (confirm("Are you sure you want to delete the album \"" + title + "\" and all its contents?\n\nThis can't be undone!")) {
      ajax(null, function(r) {
        var li = albumtitle.parentNode.parentNode;
        slide(li, 'v', null, function() {
          li.parentNode.removeChild(li);
        });
      }, '/admin.php?action=delete_album&album=' + album);
    }
    return false;
  }
}

function positionDeleter(d, i) {
  d.style.left = (i.offsetLeft + i.offsetWidth - 10) + 'px';
  d.style.top = (i.firstChild.offsetTop - 8) + 'px';
  d.style.right = 'auto';
}

function edit() {
  var content = this.parentNode.nextSibling, cancel = this.nextSibling, save = cancel.nextSibling, edit = this;
  addClass(content, 'editing');
  if (content.ident === 'maintitle' && !albumarray) {
    content.othertoolbar = $('.toolbar ~ .toolbar', content.parentNode);
    content.othercontent = $('.toolbar ~ .toolbar + *', content.parentNode);
    content.othertoolbar.style.left = 'auto';
    content.othertoolbar.style.right = (content.othercontent.offsetWidth + 8) + 'px';
  }
  addClass(this.parentNode, 'editing');
  content.original = content.innerHTML;
  content.textContent = content.innerHTML; // IE doesn't support textContent! Need this to work to allow HTML in descriptions
  if (hasClass(content, 'emptydesc') || (content.ident === 'caption' && content.lastChild.nodeName !== 'BR')) {
    removeClass(content, 'emptydesc');
    content.innerHTML += '<br>';
  }
  content.contentEditable = true;
  removeClass(save, 'hide');
  removeClass(cancel, 'hide');
  addClass(this, 'hide');
  content.focus(); // not working in IE due to bug - maybe try sticking a SPAN in so it works?
  content.onkeydown = function(e) {
    var keycode = window.event ? window.event.keyCode : e.which;
    if (keycode === 16) return this.shiftdown = true;
    if (keycode === 13 || keycode === 27) { // enter, esc
      if (this.shiftdown) return keycode === 13 && (content.ident === 'albumdesc' || content.ident === 'maindesc');
      if (keycode === 13) save_changes.call(save, true);
      else cancel_changes.call(cancel);
      this.blur();
      return false;
    }
  }
  content.onkeyup = function(e) {
    var keycode = window.event ? window.event.keyCode : e.which;
    if (keycode === 16) this.shiftdown = false;
  }
  return false;
}

function save_changes(keyed) {
  addClass(this.parentNode, 'inprogress');
  var content = this.parentNode.nextSibling, button = this, album = image = '', inputdata = content.textContent, query;
  if (albumarray && (content.ident.indexOf('album') === 0)) {
    album = content.ident === 'albumtitle' ? content : $('h3 > a[contenteditable]', content.parentNode);
    album = album.href.split('/');
    album = album[album.length-2];
  }
  else album = admin.album;
  if (content.ident === 'caption') {
    image = $('#view > div > img') || $('a:not(.deleter)', content.parentNode)[0];
    image = thumbarray ? image.href.replace(/_(?!.*_.*)/,'.') : image.src;
  }
  query = content.ident + '=' + trim(inputdata, '<br>');
  if (album) query += '&album=' + album;
  if (image) query += '&image=' + image;
  ajax(null, function(r) {
    removeClass(content, 'editing');
    removeClass(button.parentNode, 'editing');
    removeClass(button.parentNode, 'inprogress');
    addClass(button.previousSibling, 'hide');
    removeClass(button.previousSibling.previousSibling, 'hide');
    if (keyed) button.previousSibling.previousSibling.focus();
    addClass(button, 'hide');
    content.contentEditable = false;
    content.innerHTML = content.original = inputdata;
    if (inputdata.length === 0) {
      var emptystr = content.ident === 'albumtitle' ? album : 'Add a description';
      content.appendChild($t(emptystr));
      addClass(content, 'emptydesc');
    }
  }, '/admin.php?action=edit&' + query);
  if (!albumarray) position_toolbar(content);
  return false;
}

function cancel_changes() {
  var content = this.parentNode.nextSibling;
  removeClass(content, 'editing');
  removeClass(this.parentNode, 'editing');
  content.innerHTML = content.original;
  if (content.original === 'Add a description') addClass(content, 'emptydesc');
  content.contentEditable = false;
  addClass(this, 'hide');
  addClass(this.nextSibling, 'hide');
  removeClass(this.previousSibling, 'hide');
  if (!albumarray) position_toolbar(content);
  return false;
}

function position_toolbar(content) {
  if (content.ident === 'maintitle') {
    content.othertoolbar.style.right = 'auto';
    content.othertoolbar.style.left = (content.othercontent.offsetLeft - 40) + 'px';
  }
}

function toggleDisplay(el, cond, disp) {
  disp = disp || 'block';
  if (!!cond || el.style.display !== disp) el.style.display = disp;
  else el.style.display = '';
}

function toggleVis(el) {
  el.style.visibility = el.style.visibility === 'visible' ? 'hidden' : 'visible';
}

function basename(str) {
  return trim(trim(str, '\\\\').split('\\').pop(), '/').split('/').pop();
}

function jsonParse(str) {
  return window.JSON ? JSON.parse(str) : eval('('+str+')');
}

function contains(parental, descendant){
  return parental.contains ? parental.contains(descendant) : !!(descendant.compareDocumentPosition(parental) & 8);
}

function autogrow() {
  if (!this.clone) {
    this.clone = document.createElement('textarea');
    this.clone.rows = this.rows - 1;
    this.clone.className = 'autogrowclone';
    this.clone.style.visibility = 'hidden';
    this.clone.style.width = this.scrollWidth + 'px';
    this.clone.style.position = 'absolute';
    this.parentNode.insertBefore(this.clone, null);
  }
  this.clone.value = this.value;
  this.style.height = this.clone.scrollHeight + 'px';
}